!
! code to fit a sine wave to some data
!
! to compile on MSSLAH
!
!f90 sinefit_data.f90 -o sinefit_data.e 
!-L/star/lib -lsla -lnag -L/xanadu/osf/lib -lpgplot -lX11
!

      character ans*2, ch*1, lc_file*100

      integer*4 i, j, k, l, ii, jj, ios
      integer*4 seed, ifail, cts, G05DRF, ndof, ndofs(500)

      integer*4 n, nbins, nt0, nused
      logical add_noise, repeat, subt_bk, do_fit_errs, do_fit, with_gap
      logical ingap

      real*4 xp, yp
      real*8 mean, arg, t
      real*8 rf, incts, fit_pars(4), spb, cr, cr_err
      real*8 t0, amp, p, off, range_t0, model, phi_96, av

      real*8 G05CAF, dt_maxloc, xv, yv, eyv
      real*8 cts_mean, period, tref, pi, covar_errs(4)

      real*8 x(1000), y(1000), ey(1000)

!      double precision, pointer :: time(:), source(:,:)

      external G05CBF, G05ZAF, G05DRF, G05CAF, G05CCF

      pi=3.141592654d0

! get input values

      write(*,'(/," Enter file containing data -> ",$)')
      read(*,*)lc_file

      ndata=0
      mean=0.
      open(unit=1,file=lc_file,status='old')

      do while(ios.eq.0)
         read(1,*,iostat=ios)xv,yv,eyv

         if(ios.eq.0)then
            ndata=ndata+1
            x(ndata)=xv
            y(ndata)=yv
            ey(ndata)=eyv
            mean=mean+yv
         end if

      end do
      close(1)
      mean=mean/ndata


      call plot_data(x,y,ey,ndata)

      write(*,'(/," Enter starting estimates for the amplitude, t0 and &
       & period -> ",$)')
      read(*,*)amp, t0, period
      off=mean
      p=period

      do_fit=.true.
      do_fit_errs=.false.
      if(do_fit)then
         write(*,'(/," Get errors on t0 when fitting  ? -> ",$)')
         read(*,'(a)')ans
         if(ans.eq.'y'.or.ans.eq.'Y')then
            do_fit_errs=.true.
            write(*,'(" enter range to cover and number of steps -> ",$)')
            read(*,*)range_t0,nt0

         end if

      end if




      if(do_fit)call fit_sine(x,y,ey,ndata,off,amp,t0,p,covar_errs,&
        &do_fit_errs,fit_pars,chisq,ndof,range_t0,nt0)

      off=fit_pars(1)
      amp=fit_pars(2)
      t0=fit_pars(3)
      p=fit_pars(4)

      open(unit=2,file='sinewave.dmp',status='new')
      do i=1,ndata
         xp=x(i)
         t=x(i)
         arg=(t-t0)*2.d0*pi/p
         model=off + amp * sin(arg)
         yp=model
         write(2,*)x(i),model

         if(i.eq.1)then
            call pgmove(xp,yp)
         else
            call pgdraw(xp,yp)
         end if

      end do
      close(2)

      write(*,'("hit return to close plot ")')
      read(*,'(a)')ch

      call pgend


   end



! subroutine to plot generated image


subroutine plot_data(x,y,ey,ndata)

  real*8 x(1000), y(1000), ey(1000)
  real*4 xmin, xmax, ymin, ymax, xtick, ytick
  real*4 xv,yv,eyv
  character optx*6, opty*6

  integer ci,i, ndata, nxsub, nysub, sf

! set up device, view port and window

  call pgbeg(0,"?",1,1)

  call pgvport(0.05,0.05,0.95,0.95)

  xmin=1.e10
  xmax=-1.e10
  ymin=1.e10
  ymax=-1.e10

  do i=1,ndata
     if(x(i).lt.xmin)xmin=x(i)
     if(x(i).gt.xmax)xmax=x(i)
     if(y(i).lt.ymin)ymin=y(i)
     if(y(i).gt.ymax)ymax=y(i)
  end do

  call pgwindow(xmin,xmax,ymin,ymax)

  call pgsls(1)
  call pgslw(1)
!  call pgsch(1)
  xtick=0.
  ytick=0.
  optx='bcnstv'
  opty='bcnstv'
  nxsub=0
  nysub=0

  call pgbox(optx,xtick,nxsub,opty,ytick,nysub)


  sf=1
  do i=1,ndata
     xv=x(i)
     yv=y(i)
     eyv=ey(i)

     call pgpoint(1,xv,yv,sf)
     call pgmove(xv,yv-eyv)
     call pgdraw(xv,yv+eyv)

  end do

!  call pgsvp(0.05,0.95,0.05,0.95)


!  call pgscr(1,1.0,1.0,0.0)
!  call pgsci(1)
!  call pgslw(2)
  
!  call pgmove(1.0*i1,1.0*j1)
!  call pgdraw(1.0*i2,1.0*j1)
!  call pgdraw(1.0*i2,1.0*j2)
!  call pgdraw(1.0*i1,1.0*j2)
!  call pgdraw(1.0*i1,1.0*j1)


  return

  end


! task to fit a sine function to the data window.


    subroutine fit_sine(xv,yv,eyv,nbins,off,amp,t0,p,covar_errs,&
     &do_fit_errs,abest,chisqr4,ndof,range_t0,nt0)

!      double precision src(:,:), t(:)

      character params(4)*10, ans*1
      real*8 xv(1000), yv(1000), eyv(1000)
 
      integer*4 i, j, n, ibound, nbins
      integer*4 liw, lw, ma
      parameter (n=4, liw=n+2, lw=n*(n-1)/2+12*n, ma=4, nca=ma+1)
      integer*4 nout, ifail, ndata, sx, sy, i1, i2, i3, i4, i5
      integer*4 step, iter, ia(ma), mmax, ip, nt0
      parameter (mmax=20)

      real*8  tol, chisqr4

      real*8 t0, amp, p, off, factor, covar_errs(4)
      real*8 f, bl(n), bu(n), user(n), w(lw), x(n), xmin(n), a(ma)
      real*8 dzda(4), alambda, chisqr, chisqr_last, alpha(nca,nca)
      real*8 covar(nca,nca), alast(ma), del, abest(4)
      real*8 dx(n), fmin, range_t0, delchi, chi_lim, dt0_p, dt0_m
      integer*4 iuser(n), nits, ndof, nfit
      logical maska(ma), converged, do_fit_errs, found_lim

      real*8 xd(1000), yd(1000), sigd(1000)
!      real, pointer :: xd(:), yd(:), sigd(:)

      external funcs

      params(1)='mean'
      params(2)='amplitude'
      params(3)='t0'
      params(4)='period'


! first, since algorithm in book uses a `single` data values, but we are 
! dealing with a 2-D image, must set up arrays for the x,y pixel locations
! and also store the data pixel values into the data array

!      allocate(xd(1:nbins))
!      allocate(yd(1:nbins))
!      allocate(sigd(1:nbins))


      ndata=0
      do j=1,nbins

! store data suitably for mrqmin fitting later (ie need x,y locations of 
! each pixel and its value and error

         ndata=ndata+1
         xd(ndata)=xv(j)
         yd(ndata)=yv(j)
         sigd(ndata)=eyv(j)
         if(sigd(ndata).le.0.d0)sigd(ndata)=1.d0

!         write(*,*)' ndata,x,y,sig = ',ndata,xd(ndata),yd(ndata),&
!          &sigd(ndata)
      end do

      

! setup initial trial values for fits etc - offset from input values

      write(*,*)' starting pars are off,amp,t0,p = ',off,amp,t0,p
      x(1)=off
      x(2)=amp
      x(3)=t0
      x(4)=p

      ibound=0

! setup mrqmin parameters - 4 parameters

      nfit=0
      do i=1,4
         a(i)=x(i)      ! initial trial value for a's
         write(*,'(/,"Fix parameter ",a," (y/n) -> ",$)')params(i)
         read(*,'(a)')ans

         ia(i)=1        !1 means fit it
         if(ans.eq.'y'.or.ans.eq.'Y')then
            ia(i)=0   ! don't fit

            write(*,'(/,"Enter value to fix at -> ",$)')
            read(*,*)x(i)  
         end if

         if(ia(i).eq.1)nfit=nfit+1

         alast(i)=0.5*a(i)  !initialise comparison value
      end do
      alambda=-1.d0
      chisqr_last=1.d30

! call mrqmin for fitting - will need to repeat until convergence of 
! parametersis achieved and then run again with alambda=0

      converged=.false.
      tol=0.001   !tolerance - [a(i)-alast(i)] / a(i) must be <= tol

      write(*,'(/," MRQMIN FIT",/)')

      nits=0
      do while(.not.converged.and.nits.lt.10)

         call mrqmin(xd,yd,sigd,ndata,a,ia,ma,covar,alpha,nca,chisqr,&
       &alambda)

! perform convergence test on each parameter. All parameters must converge to 
! within tolerance. Chisqr must also converge - first test.

         converged=.true.
         if((chisqr.gt.0.d0.and.(chisqr_last-chisqr)/chisqr.gt.tol).or.&
          &(chisqr.eq.0.d0.and.(chisqr_last-chisqr).gt.tol))then
            chisqr_last=chisqr
            converged=.false.
         end if

         do i=1,ma
            del=abs(a(i)-alast(i))
            if(a(i).ne.0.d0.and.del/abs(a(i)).gt.tol)converged=.false.
            if(a(i).eq.0.d0.and.del.gt.tol)converged=.false.

            alast(i)=a(i)  !update for next iteration
         end do


 
         nits=nits+1

         ndof=ndata-nfit

         write(*,*)' MRQMIN iteration ',nits,' Chisqr/nu = '&
          &,chisqr/ndof

     end do

! if converged, repeat once with alambda=0 to get covar matrix


     call mrqmin(xd,yd,sigd,ndata,a,ia,ma,covar,alpha,nca,chisqr,&
       &0.d0)


!output results - quoted errors is (here) just sqrt[covar(i,i)]
     
     write(*,'(//)')
     do i=1,ma
        abest(i)=a(i)
        covar_errs(i)=sqrt(covar(i,i))
        write(*,'(" FIT a(",i2,") = ",1pe15.8," +/- ",1pe15.8)')&
         &i,abest(i),covar_errs(i)
     end do
     write(*,'(/," Final chisqr/Nu = "f12.4," nfree = ",i8)')&
      &chisqr/ndof,ndof

     chisqr4=chisqr


! and get fit errors. This is formal approach. Each parameter ALONE is stepped 
! away from its best fit value and at each step, other parameters are 
! re-fitted. As we move away, chisqr should increase. At some point, chisqr 
! will = chisqr(best fit) + delta_chisqr where delta_chisqr is a fixed value 
! based on a user-selected confidence level and number of parameters of 
! `interest`. Here, we step away from best fit on either side (+ and -) and 
! just do a fixed number of steps of pre-defined size. Could/should proceed 
! until chisqr exceeds chisqr_min + delta_chisqr but this is risky if 
! data is poor such that there are multiple close chisqr minima or the 
! chisqr space is flat/broad. 

     if(do_fit_errs)then


        write(*,'(" enter delta chisqr to add to total chisqr  -> ",$)')
        read(*,*)delchi

        chi_lim=chisqr + delchi

! get errors on parameter 3 (t0)
! do negative shift first


        found_lim=.false.
        do ip=1,nt0

           alambda=-1.d0
           ia(3)=0

           a(3)=abest(3)-ip*(range_t0/nt0)

           converged=.false.
           tol=0.001

           nits=0
           do while(.not.converged.and.nits.lt.10)

              call mrqmin(xd,yd,sigd,ndata,a,ia,ma,covar,alpha,nca,chisqr,&
                   &alambda)

              converged=.true.
              do i=1,ma
                 del=abs(a(i)-alast(i))
                 if(a(i).ne.0.d0.and.del/abs(a(i)).gt.tol)converged=.false.
                 if(a(i).eq.0.d0.and.del.gt.tol)converged=.false.
                 alast(i)=a(i)
              end do
              
              nits=nits+1
              
           end do
           
           call mrqmin(xd,yd,sigd,ndata,a,ia,ma,covar,alpha,nca,chisqr,&
             &0.d0)

           write(*,'(" For a(3) = ",f8.3," chisqr = ",f12.2," Nits = "&
                &,i5)')a(3),chisqr,nits


           if(.not.found_lim.and.chisqr.gt.chi_lim)then
              found_lim=.true.
              dt0_m=abs( a(3) - abest(3))
           end if

        end do  !steps away from best fit for param 3

! do positive shift

        write(*,*)' '

        found_lim=.false.

        do ip=1,nt0

           alambda=-1.d0
           ia(3)=0
        
           a(3)=abest(3)+ip*(range_t0/nt0)

           converged=.false.
           tol=0.001

           nits=0
           do while(.not.converged.and.nits.lt.10)

              call mrqmin(xd,yd,sigd,ndata,a,ia,ma,covar,alpha,nca,chisqr,&
                   &alambda)

              converged=.true.
              do i=1,ma
                 del=abs(a(i)-alast(i))
                 if(a(i).ne.0.d0.and.del/abs(a(i)).gt.tol)converged=.false.
                 if(a(i).eq.0.d0.and.del.gt.tol)converged=.false.
                 alast(i)=a(i)
              end do
              
              nits=nits+1

           end do

           call mrqmin(xd,yd,sigd,ndata,a,ia,ma,covar,alpha,nca,chisqr,&
                &0.d0)

           write(*,'(" For a(3) = ",f8.3," chisqr = ",f12.2," Nits = "&
                &,i5)')a(3),chisqr,nits

           if(.not.found_lim.and.chisqr.gt.chi_lim)then
              found_lim=.true.
              dt0_p=abs( a(3) - abest(3))
           end if

        end do  !steps away from best fit for param 3

     end if


!     deallocate(xd)
!     deallocate(yd)
!     deallocate(sigd)

     write(*,'(" t0 errors for given delchi are (-) ",1pe12.4," (+) &
      & ",1pe12.4)')dt0_m, dt0_p


      return
    end subroutine fit_sine



! Levenberg-Marquardt code (uses mrqcof, gaussj and covsrt and the 
! supplied function, funcs). Note adaptation to pass the extra 
! information (i.e. x and y pixel coordinates, not just x.


    SUBROUTINE mrqmin(x,y,sig,ndata,a,ia,ma,covar,alpha,nca,chisq,&
     &alamda)

      INTEGER*4 ma,nca,ndata
      integer*4 ia(ma),MMAX
      REAL*8 alamda,chisq,a(ma),alpha(nca,nca),covar(nca,nca)
      PARAMETER (MMAX=20)
!    USES covsrt,gaussj,mrqcof
      INTEGER*4 j,k,l,m,mfit
      REAL*8 ochisq,atry(4),beta(4),da(4)
      SAVE ochisq,atry,beta,da,mfit

      real*8 x(1000), y(1000), sig(1000)
!      real, pointer :: x(:), y(:), sig(:)

!      allocate(x(1:ndata))
!      allocate(y(1:ndata))
!      allocate(sig(1:ndata))

      if(alamda.lt.0.)then
        mfit=0
        do 11 j=1,ma
          if (ia(j).ne.0) mfit=mfit+1
11      continue
        alamda=0.001
        call mrqcof(x,y,sig,ndata,a,ia,ma,alpha,beta,nca,chisq)

        ochisq=chisq
        do 12 j=1,ma
          atry(j)=a(j)
12      continue
      endif
      j=0
      do 14 l=1,ma
        if(ia(l).ne.0) then
          j=j+1
          k=0
          do 13 m=1,ma
            if(ia(m).ne.0) then
              k=k+1
              covar(j,k)=alpha(j,k)
            endif
13        continue
          covar(j,j)=alpha(j,j)*(1.+alamda)
          da(j)=beta(j)
        endif
14    continue
      call gaussj(covar,mfit,nca,da,1,1)
      if(alamda.eq.0.)then
        call covsrt(covar,nca,ma,ia,mfit)
        return
      endif
      j=0
      do 15 l=1,ma
        if(ia(l).ne.0) then
          j=j+1
          atry(l)=a(l)+da(j)
        endif
15    continue
      call mrqcof(x,y,sig,ndata,atry,ia,ma,covar,da,nca,chisq)
      if(chisq.lt.ochisq)then
        alamda=0.1*alamda
        ochisq=chisq
        j=0
        do 17 l=1,ma
          if(ia(l).ne.0) then
            j=j+1
            k=0
            do 16 m=1,ma
              if(ia(m).ne.0) then
                k=k+1
                alpha(j,k)=covar(j,k)
              endif
16          continue
            beta(j)=da(j)
            a(l)=atry(l)
          endif
17      continue
      else
        alamda=10.*alamda
        chisq=ochisq
      endif

!      deallocate(x)
!      deallocate(y)
!      deallocate(sig)

      return
      END


      SUBROUTINE mrqcof(x,y,sig,ndata,a,ia,ma,alpha,beta,nalp,chisq)

      INTEGER*4 ma,nalp,ndata
      integer*4 ia(ma)
      REAL*8 chisq,a(ma),alpha(nalp,nalp),beta(4), xv, yv
      EXTERNAL funcs
      INTEGER*4 mfit,i,j,k,l,m,kk
      REAL*8 dz,sig2i, wt, zmod, dzda(4), fp(4), fm(4), delt(4)
      real*8 x(1000), y(1000), sig(1000)

!      real, pointer :: x(:), y(:), sig(:)

      mfit=0



!      allocate(x(1:ndata))
!      allocate(y(1:ndata))
!      allocate(sig(1:ndata))

      do 11 j=1,ma
        if (ia(j).ne.0) mfit=mfit+1
11    continue
      do 13 j=1,mfit
        do 12 k=1,j
          alpha(j,k)=0.
12      continue
        beta(j)=0.
13    continue
      chisq=0.

     do 16 i=1,ndata

        xv=x(i)
        call funcs(xv,ma,a,zmod,dzda)


        sig2i=1./(sig(i)*sig(i))
        dz=y(i)-zmod

        j=0
        do 15 l=1,ma
          if(ia(l).ne.0) then
            j=j+1
            wt=dzda(l)*sig2i
            k=0
            do 14 m=1,l
              if(ia(m).ne.0) then
                k=k+1
                alpha(j,k)=alpha(j,k)+wt*dzda(m)
              endif
14          continue
            beta(j)=beta(j)+dz*wt
          endif
15      continue
        chisq=chisq+dz*dz*sig2i
16    continue

      do 18 j=2,mfit
        do 17 k=1,j-1
          alpha(k,j)=alpha(j,k)
17      continue
18    continue
          
!          deallocate(x)
!          deallocate(y)
!          deallocate(sig)

      return
      END



      SUBROUTINE covsrt(covar,npc,ma,ia,mfit)

      INTEGER*4 ma,mfit,npc,ia(ma)
      REAL*8 covar(npc,npc)
      INTEGER*4 i,j,k
      REAL*8 swap
      do 12 i=mfit+1,ma
        do 11 j=1,i
          covar(i,j)=0.
          covar(j,i)=0.
11      continue
12    continue
      k=mfit
      do 15 j=ma,1,-1
        if(ia(j).ne.0)then
          do 13 i=1,ma
            swap=covar(i,k)
            covar(i,k)=covar(i,j)
            covar(i,j)=swap
13        continue
          do 14 i=1,ma
            swap=covar(k,i)
            covar(k,i)=covar(j,i)
            covar(j,i)=swap
14        continue
          k=k-1
        endif
15    continue
      return
      END


      SUBROUTINE gaussj(a,n,np,b,m,mp)
      INTEGER*4 m,mp,n,np,NMAX
      REAL*8 a(np,np),b(np,mp)
      PARAMETER (NMAX=50)
      INTEGER*4 i,icol,irow,j,k,l,ll,indxc(NMAX),indxr(NMAX),ipiv(NMAX)
      REAL*8 big,dum,pivinv
      do 11 j=1,n
        ipiv(j)=0
11    continue
      do 22 i=1,n
        big=0.
        do 13 j=1,n
          if(ipiv(j).ne.1)then
            do 12 k=1,n
              if (ipiv(k).eq.0) then
                if (abs(a(j,k)).ge.big)then
                  big=abs(a(j,k))
                  irow=j
                  icol=k
                endif
              else if (ipiv(k).gt.1) then
                pause 'singular matrix in gaussj '
              endif
12          continue
          endif
13      continue
        ipiv(icol)=ipiv(icol)+1
        if (irow.ne.icol) then
          do 14 l=1,n
            dum=a(irow,l)
            a(irow,l)=a(icol,l)
            a(icol,l)=dum
14        continue
          do 15 l=1,m
            dum=b(irow,l)
            b(irow,l)=b(icol,l)
            b(icol,l)=dum
15        continue
        endif
        indxr(i)=irow
        indxc(i)=icol
        if (a(icol,icol).eq.0.)pause 'singular matrix in gaussj a=0'
        pivinv=1./a(icol,icol)
        a(icol,icol)=1.
        do 16 l=1,n
          a(icol,l)=a(icol,l)*pivinv
16      continue
        do 17 l=1,m
          b(icol,l)=b(icol,l)*pivinv
17      continue
        do 21 ll=1,n
          if(ll.ne.icol)then
            dum=a(ll,icol)
            a(ll,icol)=0.
            do 18 l=1,n
              a(ll,l)=a(ll,l)-a(icol,l)*dum
18          continue
            do 19 l=1,m
              b(ll,l)=b(ll,l)-b(icol,l)*dum
19          continue
          endif
21      continue
22    continue
      do 24 l=n,1,-1
        if(indxr(l).ne.indxc(l))then
          do 23 k=1,n
            dum=a(k,indxr(l))
            a(k,indxr(l))=a(k,indxc(l))
            a(k,indxc(l))=dum
23        continue
        endif
24    continue
      return
      END


! subroutine to compute the model function. Needs derivatives. Since we 
! are integrating function over arbitrary sized pixels, must get these 
! numerically using finite differences.
 
      subroutine funcs(x,ma,a,zfit,dzda)

      integer*4 ma
      real*8 x, a(ma), zfit, dzda(4), astore(ma), sigma
      real*8 off, amp, t0, p, r, vpix, gauss
      real*8 arg, xs, ys, err, pixv, delta_a, alpha
      real*8 ang, den, fp(4), fm(4), delt(4), pi

      integer*4  k, l, i, j, nsubpix, nsub, ix, jy
      integer*4 jj, ii


      pi=3.141592654d0

! set up parameters

      off=a(1)
      amp=a(2)
      t0=a(3)
      p=a(4)


! For the given data pixel, integrate function over it by dividing the pixel
! into nsub sub pixels, summing the function over these and then getting
! the average value. 

      arg=2.d0*pi*(x-t0)/p

      zfit = off + amp*sin(arg)


! and determine gradient

      dzda(1)=1.d0
      dzda(2)=sin(arg)
      dzda(3)=(-2.d0*pi*amp/p) * cos(arg)
      dzda(4)=(-2.d0*pi*(x-t0)*amp/(p*p)) * cos(arg)


      return
    end subroutine funcs

